/*********************************************************************
 *
 * Authors: Vincenzo Ciaschini - Vincenzo.Ciaschini@cnaf.infn.it 
 *
 * Copyright (c) 2002, 2003 INFN-CNAF on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or
 * http://www.edg.org/license.html
 *
 * Parts of this code may be based upon or even include verbatim pieces,
 * originally written by other people, in which case the original header
 * follows.
 *
 *********************************************************************/

#include <netdb.h>
#include <string.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "globus_config.h"
#include "gssapi.h"
#include "gssapi_compat.h"
#include "globus_gss_assist.h"

#include <openssl/x509.h>
#include <openssl/asn1.h>
#include <openssl/e_os.h>

#include "voms_apic.h"


static int check(struct collection *, int *,  char *, char *);
static int check_cert(X509 *, int *,  char *);
static int MS_CALLBACK cb(int, X509_STORE_CTX *);
static int id_data(char **, char **, int *);
static char *get_globusid(gss_cred_id_t);
static int   get_number(char **, char *, char *);
static char *get_name(char **, char *, char *);
static struct collection *unformat(char **, int, int *);
static int parse_rest(char *, int, struct collection *, int *);
int net_connect(char *, int, char *, char *, int, char **, int *, char **, char **);
char **listadd(char **, char *, int);
static char *getMCA(void *);
static int verifysig(EVP_PKEY *, char *, char *, int, int);
int verify(char *, int, struct vomsdata *, char *, char *, int *);
static int send_token(void *, void *, size_t);
static int get_token(void *, void **, size_t *);
static struct collection *unformat(char **, int, int *);
